/*
 * Copyright 2000-2017 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jetbrains.uast.java

import com.intellij.psi.PsiElement
import com.intellij.psi.PsiNamedElement
import org.jetbrains.uast.*

class JavaUCompositeQualifiedExpression(
    override val psi: PsiElement,
    override val uastParent: UElement?
) : JavaAbstractUExpression(), UQualifiedReferenceExpression {
    override lateinit var receiver: UExpression
        internal set

    override lateinit var selector: UExpression
        internal set

    override val resolvedName: String?
        get() = (resolve() as? PsiNamedElement)?.name

    override fun resolve() = (selector as? UResolvable)?.resolve()

    override val accessType: UastQualifiedExpressionAccessType
        get() = UastQualifiedExpressionAccessType.SIMPLE
}